// GetParent.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "stdio.h"
#include "resource.h"

#define MAX_LOADSTRING 100
#define ID_FIRSTCHILD  100 
#define ID_SECONDCHILD 101 
#define ID_THIRDCHILD  102 

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;
	WNDCLASS wc;

	// Initialize global strings
	::GetClassInfo(hInstance, "#32770", &wc);
	wc.lpszClassName = "MyPrivateClassName";
	wc.lpfnWndProc = (WNDPROC) WndProc;

	RegisterClass(&wc);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_GETPARENT);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindowEx(WS_EX_DLGMODALFRAME,"MyPrivateClassName", szTitle,  WS_VISIBLE | WS_CAPTION | WS_SYSMENU,//WS_OVERLAPPED|WS_DLGFRAME,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

BOOL CALLBACK EnumChildProc(HWND hwndChild, LPARAM lParam) 
{ 
    LPRECT rcParent; 
    int i, idChild; 
 
    // Retrieve the child-window identifier. Use it to set the 
    // position of the child window. 
 
    idChild = GetWindowLong(hwndChild, GWL_ID); 
 
    if (idChild == ID_FIRSTCHILD) 
        i = 0; 
    else if (idChild == ID_SECONDCHILD) 
        i = 1; 
    else 
        i = 2; 
 
    // Size and position the child window.  
 
    rcParent = (LPRECT) lParam; 
    MoveWindow(hwndChild, 
        (rcParent->right / 3) * i, 
        0, 
        rcParent->right / 3, 
        rcParent->bottom, 
        TRUE); 
 
    // Make sure the child window is visible. 
 
    ShowWindow(hwndChild, SW_SHOW); 
 
    return TRUE; 
} 

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent,i;
	RECT rcClient; 
	DWORD dwValue;
	WORD dwID;
	DWORD dwStyle;
	char Window[255];

	switch (message) 
	{
		case WM_CREATE:
 
            for (i = 0; i < 3; i++) 
            {
				if( i == 0 )
					dwStyle = BS_DEFPUSHBUTTON | WS_CHILD | WS_GROUP | WS_TABSTOP;
				else
					dwStyle = BS_PUSHBUTTON | WS_CHILD | WS_GROUP | WS_TABSTOP;

				sprintf(Window,"Button %d", ID_FIRSTCHILD + i);
                CreateWindowEx( 
                    0, 
                    "Button", 
                    (LPCTSTR) Window, 
                    dwStyle, 
                    0,0,0,0, 
                    hWnd, 
                    (HMENU) (int) (ID_FIRSTCHILD + i), 
                    hInst, 
                    NULL); 
            }
			return 0;
 
        case WM_SIZE:   // main window changed size 
 
            // Get the dimensions of the main window's client 
            // area, and enumerate the child windows. Pass the 
            // dimensions to the child windows during enumeration. 
 
            GetClientRect(hWnd, &rcClient); 
            EnumChildWindows(hWnd, EnumChildProc, 
                (LPARAM) &rcClient); 
            return 0; 
        // Process other messages. 

		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				case ID_FIRSTCHILD:
					{
						dwValue = SendMessage(hWnd, DM_GETDEFID, 0L, 0L);
						if( HIWORD(dwValue) == DC_HASDEFID)
							dwID = LOWORD(dwValue);
						SendDlgItemMessage(hWnd, ID_FIRSTCHILD,BM_SETSTYLE, BS_PUSHBUTTON, (LONG)TRUE); 
						SendMessage(hWnd, DM_SETDEFID, ID_SECONDCHILD, 0L);
						SendDlgItemMessage(hWnd, ID_SECONDCHILD,BM_SETSTYLE, BS_DEFPUSHBUTTON, (LONG)TRUE); 
						dwValue = SendMessage(hWnd, DM_GETDEFID, 0L, 0L);
						if( HIWORD(dwValue) == DC_HASDEFID)
							dwID = LOWORD(dwValue);
					}
					break;
				case ID_SECONDCHILD:
					{
						dwValue = SendMessage(hWnd, DM_GETDEFID, 0L, 0L);
						if( HIWORD(dwValue) == DC_HASDEFID)
							dwID = LOWORD(dwValue);
						SendDlgItemMessage(hWnd, ID_SECONDCHILD,BM_SETSTYLE, BS_PUSHBUTTON, (LONG)TRUE); 
						SendMessage(hWnd, DM_SETDEFID, ID_FIRSTCHILD, 0L);
						SendDlgItemMessage(hWnd, ID_FIRSTCHILD,BM_SETSTYLE, BS_DEFPUSHBUTTON, (LONG)TRUE); 
						dwValue = SendMessage(hWnd, DM_GETDEFID, 0L, 0L);
						if( HIWORD(dwValue) == DC_HASDEFID)
							dwID = LOWORD(dwValue);
					}
					break;
				case ID_THIRDCHILD:
					DestroyWindow(hWnd);
					break;

				default:
				   return DefDlgProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefDlgProc(hWnd, message, wParam, lParam);
   }
   return 0;
}
